<?php
    if ( ! defined( 'ABSPATH' ) ) exit;
?>

<script>

    class AdminPage {

        constructor() {
            this.alias = {type: 'string'};
            this.cameraWidth = 0;
            this.cameraHeight = 0;
            this.aspect_ratio = 0;
            this.box_width = 0;
            this.features = {};
            this.selected_features_arr = [];
            this.final_array = [];
            this.itemId = 0;

            this.load_storage();
            this.trigger_new_camera_btn();
            this.trigger_save_btn();
            this.trigger_checkboxes();
            this.trigger_apply_btn();
            this.trigger_item_delete_btn();
            this.trigger_item_delete_yes_btn();
            this.trigger_item_edit_btn();
            this.trigger_apply_edit_btn();
            this.window_resize();
        }

        load_storage() {
            if ( JSON.parse(localStorage.getItem('items')) != null ) {
                this.show_setuped_cameras();

                for ( let i=0; i<JSON.parse(localStorage.getItem('items')).length; i++ ) {
                    this.final_array.push(JSON.parse(localStorage.getItem('items'))[i]);
                };
            };
        }

        save_camera(new_alias) {
            this.alias = new_alias;
            this.post_method();
            
            jQuery("#video-block").css("display","flex");

            this.padding_setup();
        }

        post_method() {
            jQuery.get('https://ipcamlive.com/services/wordpress/getcamerainfo.php?alias='+this.alias, {}, data => {
                if ( data.result == 'ok' ) {
                    jQuery('.ipcl_alert_block').addClass('d-none');
                    jQuery('#camera_setup_block').removeClass('d-none');

                    let storageenabled = data.data.storageenabled;
                    let timelapseenabled = data.data.timelapseenabled;
                    let camera_width = data.data.width;
                    let camera_height = data.data.height;

                    if ( (camera_width != 0 && camera_width != null) && (camera_height != 0 && camera_height != null) ) {
                        this.cameraWidth = camera_width;
                        this.cameraHeight = camera_height;
                        this.aspect_ratio = (camera_height / camera_width);   
                    } else {
                        this.cameraWidth = 1280;
                        this.cameraHeight = 720;
                        this.aspect_ratio = 0.5625;
                    };

                    jQuery(".switch-btns").css("display","block");

                    if ( storageenabled == 0 ) {
                        jQuery(".switch4").css("display","none");
                    };

                    if ( timelapseenabled == 0 ) {
                        jQuery(".switch3").css("display","none");
                    };

                    if ( storageenabled == 0 && timelapseenabled == 0 ) {
                        jQuery(".switch11").css("display","none");
                        jQuery(".switch12").css("display","none");
                    };

                    //camera resize
                    this.camera_size();
                } else {
                    if (jQuery('#cameraAlias').val() != "") {
                        jQuery('.ipcl_alert_block').removeClass('d-none');
                        jQuery('#camera_setup_block').addClass('d-none');

                        jQuery('.ipcl_alert_block').html(`
                            <h6 class="alert alert-danger d-flex align-items-center" role="alert">Invalid camera alias. Check your valid camera alias <a class="btn btn-link p-0 ps-1" href="https://ipcamlive.com/cameras">here</a>.</h6>`);
                        window.scrollTo({ top: 0, behavior: 'smooth' });
                    }
                };

            },'json');
        }

        camera_size() {
            this.box_width = 0;
            
            if ( this.aspect_ratio > 1 ) {
                this.box_width = (1 / this.aspect_ratio);
                this.aspect_ratio = 1;
            } else {
                this.box_width = 1; 
            };
            this.video_embed();
        }

        video_embed() {
            var width = jQuery('#video-block').width();
            var height = jQuery('#video-block').height();

            jQuery('#mediadiv').width(width * this.box_width).height(width * this.aspect_ratio);

            ipcamliveplayer.embed('mediadiv', this.alias, this.features);
        }

        padding_setup() {

            jQuery(".no-checked").css({textAlign: 'end'});

            let sliderHeight = jQuery(".slider").height();
            let spanHeight = jQuery(".span").height();
            let marginTop = (sliderHeight/2) - (spanHeight/2);

            jQuery(".span").css({marginTop: `${marginTop}px`});

        }

        set_checkboxes_basic() {
            let all_checkboxes = document.querySelectorAll(".checkbox");

            for ( let i=0; i < all_checkboxes.length; i++ ) {
                if(all_checkboxes[i].checked)
                {
                    jQuery("#"+all_checkboxes[i].id).click();
                };
            };
        }

        save_final_storage(edit) {
            let items = {
                debug: this.debug_enabled,
                alias: this.alias,
                camera: `Camera-${this.alias}`,
                features: this.features,
                selectedFeaturesId: this.selected_features_arr,
                cameraWidth: this.cameraWidth,
                cameraHeight: this.cameraHeight,
                aspect_ratio: this.aspect_ratio,
                box_width: this.box_width,
            };

            if ( edit === false ) {
                this.final_array.push(items);
            } else {
                this.final_array[this.itemId] = items;
            };

            localStorage.setItem('items', JSON.stringify(this.final_array));

            this.show_setuped_cameras();

        }

        show_setuped_cameras(){
            jQuery("#applied_cameras").empty();

            let ip = {};

            for ( let i=0; i < JSON.parse(localStorage.getItem('items')).length; i++ ) {
                jQuery("#applied_cameras").append(`
                    <tr>
                        <td>${JSON.parse(localStorage.getItem('items'))[i].camera}:</td>
                        <td><div id="mediadiv${i}"> </div></td>
                        <td>
                            <div class="d-flex justify-content-center">
                                <button type='button' id='${JSON.parse(localStorage.getItem('items'))[i].alias}' data-id='${i}' class='btn item_edit mb-2' style="margin-right: 5px;">Edit</button><button type='button' id='${i}' class='btn item_delete mb-2' style="margin-left: 5px;">Delete</button>
                            </div>
                        </td>
                    </tr>`);
                jQuery('#mediadiv'+i).width(300).height(225);
                ip[i] = new iplayer();
                ip[i].embed(`mediadiv${i}`, JSON.parse(localStorage.getItem('items'))[i].alias, JSON.parse(localStorage.getItem('items'))[i].features);
            };
        }

        delete_item(itemId){
            this.final_array = JSON.parse(localStorage.getItem('items'));

            this.final_array.splice(itemId, 1);

            localStorage.setItem('items', JSON.stringify(this.final_array));

            this.show_setuped_cameras();
            
        }

        trigger_new_camera_btn() {
            jQuery(document).on("click","#new-camera", () => {
                jQuery("#camera_setup_block").removeClass('d-none');

                jQuery("#video-block").hide();
                
                jQuery("#cameraAlias").val("");
                jQuery("#cameraAlias").prop('readonly', false);
                jQuery("#save_btn").css("visibility","visible");

                jQuery("#apply-buttons").empty();
                jQuery("#apply-buttons").append(`<button id="apply" type="button" class="btn apply">Apply camera setup</button>`);
            });
        }

        trigger_save_btn() {
            jQuery(document).on("click", "#save_btn", () => {
                let new_alias = jQuery("#cameraAlias").val();
                
                this.save_camera(new_alias);

                this.set_checkboxes_basic();
            });
        }

        trigger_checkboxes() {
            jQuery(document).on('change', '.checkbox', e => {
                let selectedId = e.target.id;
                let selectedSpan = jQuery('#'+selectedId).siblings().children();
                let all_checkboxes = document.querySelectorAll(".checkbox");
                this.selected_features_arr = [];

                for ( let i=0; i < all_checkboxes.length; i++ ) {
                    if ( all_checkboxes[i].checked == true ) {
                        if ( all_checkboxes[i].id == 'switch0' ) {
                            this.features[jQuery('#'+all_checkboxes[i].id).attr('data-feature')] = 'orange';
                        } else {
                            this.features[jQuery('#'+all_checkboxes[i].id).attr('data-feature')] = 1;
                        };
                        this.selected_features_arr.push(all_checkboxes[i].id);
                    } else {
                        if ( all_checkboxes[i].id == 'switch0' ) {
                            this.features[jQuery('#'+all_checkboxes[i].id).attr('data-feature')] = 'white';
                        } else {
                            this.features[jQuery('#'+all_checkboxes[i].id).attr('data-feature')] = 0;
                        };
                    };
                };

                this.padding_setup();
                this.video_embed();

                if ( e.target.checked === true ) {
                    jQuery("#"+selectedSpan[0].id).css({display: 'none'});
                    jQuery("#"+selectedSpan[1].id).css({display: 'block'});
                } else {
                    jQuery("#"+selectedSpan[0].id).css({display: 'block'});
                    jQuery("#"+selectedSpan[1].id).css({display: 'none'});
                };
            })
        }

        trigger_apply_btn() {
            jQuery(document).on("click", "#apply", () => {
                this.save_final_storage(false);

                jQuery("#camera_setup_block").addClass("d-none");

                jQuery("#applied_cameras")[0].scrollIntoView({
                    behavior: "smooth",
                    block: "start"
                });

            });
        }

        trigger_item_delete_btn() {
            jQuery(document).on("click", ".item_delete", event => {
                jQuery("#item_delete_yes").attr("data-id", event.target.id);
    
                jQuery("#modalId").show("slow");
            });
        }

        trigger_item_delete_yes_btn() {
            jQuery(document).on("click", "#item_delete_yes", e => {
                this.delete_item(e.target.getAttribute("data-id"));

                jQuery("#camera_setup_block").addClass("d-none");

                jQuery("#modalId").hide();

            });
        }

        trigger_item_edit_btn() {
            jQuery(document).on("click", ".item_edit", e => {
                let itemId = e.target.getAttribute('data-id');
                this.itemId = itemId;
                let new_alias = JSON.parse(localStorage.getItem('items'))[itemId].alias;

                jQuery("#camera_setup_block").removeClass("d-none");

                jQuery("#apply-buttons").empty();
                jQuery("#apply-buttons").append(`<button id="${itemId}" type="button" class="btn apply apply-edit">Apply changes</button>`);

                jQuery("#cameraAlias").prop('readonly', true);
                jQuery("#cameraAlias").val(new_alias);
                jQuery("#save_btn").css("visibility","hidden");

                this.set_checkboxes_basic();
                
                for ( let i=0; i < JSON.parse(localStorage.getItem('items'))[itemId].selectedFeaturesId.length; i++ ) {
                    jQuery('#'+JSON.parse(localStorage.getItem('items'))[itemId].selectedFeaturesId[i]).click();
                };

                this.padding_setup();
                this.save_camera(new_alias);

                jQuery("#mediadiv")[0].scrollIntoView({
                    behavior: "smooth",
                    block: "center"
                });
            });
        }

        trigger_apply_edit_btn() {
            jQuery(document).on("click", ".apply-edit", e => {
                this.save_final_storage(true);

                jQuery("#camera_setup_block").addClass("d-none");

                jQuery("#applied_cameras")[0].scrollIntoView({
                    behavior: "smooth",
                    block: "start"
                });

            });
        }

        window_resize() {
            jQuery(window).resize(() => {
                this.post_method();
            })
        }

    }

    jQuery(document).ready(() => {
        const adminPage = new AdminPage();
    })

</script>
